<template>
  <div
    class="provider-type-module-five rounded-lg"
    :class="{
      __ishover: isHover[position] || isMobile,
    }"
  >
    <div
      class="card-container relative rounded-lg"
      :class="{
        __ishover: isHover[position] || isMobile || isSmallestBreakPoint,
      }"
    >
      <img
        class="w-full h-full absolute top-0 left-0 object-cover rounded-lg z-[2]"
        :src="
          getAssetImage(
            `assets/theme/common/LobbySettings/${dataForDisplay.SelectedModule.replace(
              /\s/g,
              ''
            )}/${dataForDisplay.SelectedStyle}/bg_text_${position.replace(
              /\s/g,
              ''
            )}.svg`
          )
        "
        alt=""
      />
      <img
        v-show="isHover[position] || isSmallestBreakPoint"
        class="absolute top-0 left-0 z-[2] h-full"
        :src="
          getAssetImage(
            `assets/theme/common/LobbySettings/${dataForDisplay.SelectedModule.replace(
              /\s/g,
              ''
            )}/${dataForDisplay.SelectedStyle}/${position.replace(
              /\s/g,
              ''
            )}.png`
          )
        "
      />
      <div
        class="flex flex-col gap-2 w-[245px] items-center transition-transform z-[3] play-now-section px-2"
        :class="{
          __ishover: isHover[position],
          '!items-end': isMobile || isSmallestBreakPoint,
        }"
      >
        <span
          class="text-center font-black text-4xl text-white italic w-full position__title uppercase"
          style="word-break: break-word"
        >
          {{ $t(position.replace(/\s/g, "_").toLowerCase()) }}
        </span>
        <span
          v-if="isHover[position] || isMobile || isSmallestBreakPoint"
          class="border-[1px] border-white rounded-lg py-2 px-4 w-[109px] cursor-pointer play-now-btn relative text-white"
          @click="() => handleRedirect(position)"
        >
          {{ $t("play_now") }}
          <div
            class="absolute top-0 left-0 w-full h-full btn-flare hidden"
            :class="{
              '!block': isMobile || isSmallestBreakPoint,
            }"
          >
            <div class="btn-flare-1 h-full absolute left-0"></div>
            <div class="btn-flare-2 h-full absolute left-9"></div>
          </div>
        </span>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { ILobbySettingsText } from "@/models/customizeTheme";

const props = defineProps<{
  data: ILobbySettingsText;
  position: string;
  index: number;
  isHover: Record<string, boolean>;
  handleRedirect: (position: string) => void;
}>();
const dataForDisplay = computed(() => props.data);
const { getAssetImage } = commonHelper;
const bgUrl = computed(
  () =>
    `url(${getAssetImage(
      `assets/theme/common/LobbySettings/${dataForDisplay.value.SelectedModule.replace(
        /\s/g,
        ""
      )}/${dataForDisplay.value.SelectedStyle}/bg_${props.position.replace(
        /\s/g,
        ""
      )}.svg`
    )})`
);
const isMobile = !useDevice().isDesktop;
const isSmallestBreakPoint = ref(false);
window.addEventListener("resize", (e: any) => {
  isSmallestBreakPoint.value = window.innerWidth < 652;
});
</script>

<style lang="scss">
:root {
  --bgl-1: #000840;
  --bgl-2: #001c96;
}
.provider-type-module-five {
  .card-container {
    width: 250.67px;
    height: 240px;
    background: linear-gradient(to left, var(--bgl-1), var(--bgl-2));
    display: flex;
    justify-content: center;
    align-items: center;
    transition: width 0.3s ease;
    &::after {
      content: "";
      background-size: 100% 100%;
      width: 100%;
      height: 100%;
      position: absolute;
      background: v-bind(bgUrl);
      border-radius: 8px;
      background-repeat: no-repeat;
    }
    &.__ishover {
      width: 400px;
    }
  }
  .play-now-section {
    &.__ishover {
      width: 175px;
      animation: translateRight 0.5s forwards;
    }
    span {
      text-shadow: 0px 0px 4px #00000066;
    }
    .play-now-btn {
      overflow: hidden;
      font-size: 16px;
      font-weight: 900;
      width: auto;
      height: auto;
      font-style: italic;
      &:hover {
        padding: 12px, 19.2px, 12px, 19.2px;
        font-size: 19.2px;
        font-weight: 900;
        font-style: italic;
        .btn-flare {
          display: block;
        }
      }
    }
    .btn-flare-1 {
      background: white;
      opacity: 20%;
      height: 100%;
      width: 56px;
      clip-path: polygon(43% 0, 88% 0, 48% 100%, 0 100%);
      animation: flareToRight 1.7s infinite;
    }
    .btn-flare-2 {
      background: white;
      opacity: 20%;
      height: 100%;
      width: 36px;
      clip-path: polygon(60% 0px, 100% 0, 37% 100%, 0px 100%);
      animation: flareToRight 1.7s infinite;
    }
  }
  @keyframes translateRight {
    0% {
      transform: translateX(0);
    }
    100% {
      transform: translateX(100px);
    }
  }
  @keyframes flareToRight {
    0% {
      transform: translateX(-50px);
    }
    100% {
      transform: translateX(140px);
    }
  }
  @media screen and (min-width: 1024px) and (max-width: 1280px) {
    .card-container {
      width: 188.81px;
      height: 188.81px;
    }
  }
  @media screen and (min-width: 768px) and (max-width: 1023px) {
    .card-container {
      width: 137.6px;
      height: 137.6px;

      &.__ishover {
        width: 360px;
      }
      .play-now-section {
        &.__ishover {
          padding-right: 64px;
          width: 170px;
        }
        .position__title {
          font-size: 24px;
        }
        .play-now-btn {
          font-size: 10px;
          &:hover {
            font-size: 12px;
          }
        }
      }
    }
  }
  @media screen and (min-width: 652px) and (max-width: 767px) {
    .card-container {
      width: 112px;
      height: 112px;

      &.__ishover {
        width: 360px;
      }
      .play-now-section {
        &.__ishover {
          padding-right: 64px;
          width: 170px;
        }
        .position__title {
          font-size: 12px;
        }
        .play-now-btn {
          font-size: 10px;
          &:hover {
            font-size: 12px;
          }
        }
      }
    }
  }
  @media screen and (max-width: 651px) {
    .card-container {
      height: 120px;
      &.__ishover {
        width: 100%;
      }
      .play-now-section {
        position: absolute;
        right: 16px;
        animation: unset;
        width: fit-content;
        .position__title {
          font-size: 24px;
        }
        .play-now-btn {
          font-size: 14px;
          &:hover {
            font-size: 16px;
          }
        }
      }
    }
  }
}
</style>
